/*
 * $Id: sign.c 1685 2006-12-12 10:45:01Z davide $
 */


#include "../wssecurity.h"
#include <libxml/xmlmemory.h>

#include <stdio.h>

char buf[1024 * 1024];

char *idList[32] = {"wsu-timestamp", "wsu-body", "wsu-bst", 0}; 

/* {"Id-8782-2863-1163415784", "Id-7629-3559-1163415784", "Id-1537-8604-1163415784", "Id-1803-7348-1163415784", "Id-8212-8280-1163415784" , "Id-1793-7806-1163415784", "Id-2455-3175-1163415784"}; */

/*{"Id-0384-9970-1163413662", "Id-2101-7311-1163413662", "Id-0128-0383-1163413662", "Id-1263-8503-1163413662", "Id-2281-3885-1163413662", "Id-0433-3575-1163413662", "Id-9372-9222-1163413662", 0};*/ 

int main(int argc, char *argv[]) {

  FILE *fp = NULL;
  char *signed_doc = NULL;

  char *bst_id = "#wsu-bst";

  if(argc < 2) {
    fprintf(stderr, "Info:\r\n  Rev: %s\r\n  Date: %s\r\n  Build Date: %s\r\n  XMLSEC Version: %s\r\n  LIBXML Version: %s\r\n",
	    WSSECURITY_Rev,
	    WSSECURITY_Date,
	    WSSECURITY_Build_Date,
	    WSSECURITY_XMLSEC_Version,
	    WSSECURITY_LIBXML_Version);

    fprintf(stderr, "Invalid arguments\r\n");
    return 1;
  }

  if(argc > 1) {
    bst_id = argv[2];
  }

  if(argc > 2) {
    int i;

    for(i = 0; i < argc - 2; i++) {
      idList[i] = argv[i + 3];      
    }

    idList[i + 1] = 0;
  }

  fp = fopen(argv[1], "r");

  if(!fp) {
    perror(argv[1]);
    return 1;
  }

  fread(&buf, sizeof(buf), sizeof(char), fp);
  fclose(fp);

  signed_doc = wssecurity_sign_mem(buf, bst_id, idList, 
				   "/home/www-data/cohesion/cohesionkey.pem", 
				   NULL,
				   "/home/www-data/cohesion/cohesioncer.pem");

  if(!signed_doc) return 1;

  fprintf(stdout, "%s\r\n", signed_doc);  

  free(signed_doc);

  return 0;
}
