/*
 * $Id: test.c 1685 2006-12-12 10:45:01Z davide $
 */


#include "../wssecurity.h"
#include <stdio.h>

char buf[1024 * 1024];

char *idList[32] = {"wsu-timestamp", "wsu-body", "wsu-bst", 0}; 
char *cerList[32] = {"/home/www-data/cohesion/cohesioncer.pem", "/home/www-data/cohesion/cohesion_root.pem", 0};

int main(int argc, char *argv[]) {

  FILE *fp = NULL;
  char *signed_doc = NULL;
  char *bst_id = "#wsu-bst";
  int retval = 0;

  if(argc < 2) {
    fprintf(stderr, "Info:\r\n  Rev: %s\r\n  Date: %s\r\n  Build Date: %s\r\n  XMLSEC Version: %s\r\n  LIBXML Version: %s\r\n",
	    WSSECURITY_Rev,
	    WSSECURITY_Date,
	    WSSECURITY_Build_Date,
	    WSSECURITY_XMLSEC_Version,
	    WSSECURITY_LIBXML_Version);

    fprintf(stderr, "Invalid arguments\r\n");
    return 1;
  }

  if(argc > 1) {
    bst_id = argv[2];
  }

  if(argc > 2) {
    int i;

    for(i = 0; i < argc - 2; i++) {
      idList[i] = argv[i + 3];      
    }

    idList[i + 1] = 0;
  }

  fp = fopen(argv[1], "r");

  if(!fp) {
    perror(argv[1]);
    return 1;
  }

  fread(&buf, sizeof(buf), sizeof(char), fp);
  fclose(fp);

  signed_doc = wssecurity_sign_mem(buf, bst_id, idList, 
				   "/home/www-data/cohesion/cohesionkey.pem", 
				   NULL,
				   "/home/www-data/cohesion/cohesioncer.pem");

  if(!signed_doc) {
    fprintf(stderr, "Signature FAILED\r\n");
    return 1;
  }

  fprintf(stdout, "%s\r\n", signed_doc);  

  retval = wssecurity_verify_mem(signed_doc, cerList);

  if(retval == 0) {
    fprintf(stderr, "Verify Ok.\r\n");
  } else {
    fprintf(stderr, "Verify FAILED (%d).\r\n", retval);
  }

  free(signed_doc);

  return(retval == 0 ? 0 : 1);
}
