/*
 * $Id: verify.c 1618 2006-11-25 12:32:34Z davide $
 */


#include "../wssecurity.h"
#include <stdio.h>


char buf[1024 * 1024];

char *files[32] = {"", 0};

int main(int argc, char *argv[]) {

  FILE *fp = NULL;
  int retval = 0;
  
  if(argc < 2) {
    fprintf(stderr, "Info:\r\n  Rev: %s\r\n  Date: %s\r\n  Build Date: %s\r\n  XMLSEC Version: %s\r\n  LIBXML Version: %s\r\n",
	    WSSECURITY_Rev,
	    WSSECURITY_Date,
	    WSSECURITY_Build_Date,
	    WSSECURITY_XMLSEC_Version,
	    WSSECURITY_LIBXML_Version);

    fprintf(stderr, "Invalid arguments\r\n");
    return 1;
  }

  if(argc > 2) {
    int j = 0;

    for(j = 0; j < argc - 2; j++) {
      files[j] = argv[j + 2];
    }

    files[j+1] = NULL;
  }

  fp = fopen(argv[1], "r");

  if(!fp) {
    perror(argv[1]);
    return 1;
  }

  fread(&buf, sizeof(buf), sizeof(char), fp);
  fclose(fp);

  retval = wssecurity_verify_mem(buf, files);

  if(retval == 0) {
    fprintf(stderr, "Signature Ok.\r\n");
  } else {
    fprintf(stderr, "Signature FAILED (%d).\r\n", retval);
  }

  return(retval == 0 ? 0 : 1);
}
