/**
 *
 * $Id: wssecurity.h 1634 2006-11-29 10:07:40Z davide $
 * Author: Davide Principi <d.principi@provincia.ps.it>
 *
 * Copyright (C) 2006 Amministrazione Provinciale di Pesaro e Urbino - Italy  
 * 
 * This is free software; see GPL.txt file in the source
 * distribution for preciese wording.
 *
 */

#ifndef __WSSECURITY_H__
#define __WSSECURITY_H__

#include <xmlsec/version.h>
#include <libxml/xmlversion.h>
/* Commento Davide */

char * wssecurity_sign_mem(const char* templateMsg, 
			   const char *idSecurityToken,
			   char **stringList,
			   const char* keyFile, 
			   const char* password,
			   const char* certFile);

int wssecurity_verify_mem(const char* xmlMessage, 
			  char** stringList);


#ifndef SWIG
#endif /*SWIG*/

extern const char *const WSSECURITY_Date;
extern const char *const WSSECURITY_Build_Date;
extern const char *const WSSECURITY_Rev;
extern const char *const WSSECURITY_SECEXT_NS;
extern const char *const WSSECURITY_XMLSEC_Version;
extern const char *const WSSECURITY_LIBXML_Version;
extern const char *const WSSECURITY_OPENSSL_Version;

#endif
